import PropTypes from "prop-types";
import styles from "./changeLogInput.module.css";

const ChangeLogInput = (props) => {
  const handleClick = () => {
    const topics = getTopics(props.logInput);

    const newEntry = {
      body: props.logInput,
      topics: topics,
      date: new Date(),
      id: crypto.randomUUID(),
    };

    props.setFeed([newEntry, ...props.feed]);
    props.setLogInput("");
  };

  return (
    <div className={styles.container}>
      <textarea
        rows="1"
        placeholder="What did you change...?!"
        className={styles.input}
        onChange={(e) => props.setLogInput(e.target.value)}
        value={props.logInput}
      />
      <button onClick={handleClick} className={styles.btn}>
        Log it!
      </button>
    </div>
  );
};

const getTopics = (body) => {
  const re = /#\w+/g;
  let topics = [];
  const matchs = [...body.matchAll(re)];

  matchs.forEach((match) => (topics = topics.concat(match[0])));

  return topics;
};

ChangeLogInput.propTypes = {
  setLogInput: PropTypes.func,
  logInput: PropTypes.string,
  feed: PropTypes.array,
  setFeed: PropTypes.func,
};

export default ChangeLogInput;
