import { dateParser } from "./dateParser";
import { describe, it, expect } from "vitest";

describe("Date Parser", () => {
  it("should have 0m for new entries", () => {
    const currentTime = new Date();
    const timeString = dateParser(currentTime);
    expect(timeString).toMatch(/0m/);
  });

  it("Should return (n)m for entries older than 30 minutes", () => {
    const currentTime = new Date();
    currentTime.setMinutes(currentTime.getMinutes() + 30);
    const timeString = dateParser(currentTime);
    expect(timeString).toMatch(/30m/);
  });

  it("should return (n)h for entires aged over an hour", () => {
    const currentTime = new Date();
    currentTime.setHours(currentTime.getHours() - 2);
    const timeString = dateParser(currentTime);
    expect(timeString).toMatch(/2h/);
  });

  it("should return the date for entries older than 24 hours", () => {
    const currentTime = new Date();
    currentTime.setDate(currentTime.getDate() - 1);
    const timeString = dateParser(currentTime);
    expect(timeString).toBeTypeOf("string");
  });
});
